package BBUVA;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.text.DecimalFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;

// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
// #[regen=yes,id=DCE.423926E6-B368-AB11-4099-04C8E11634D1]
// </editor-fold> 
public class Sucursal {

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.ED08B967-6F40-4C39-25A9-F88A44C7EF9F]
    // </editor-fold> 
    private ArrayList<Producto> mProducto;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.7D58854E-FD70-DFB5-097B-5B6E8BFBDC22]
    // </editor-fold> 
    private ArrayList<Remesa> mRemesa;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.DFF33FA2-D8CA-4E99-CD00-4DB0874EE7DF]
    // </editor-fold> 
    public Sucursal () {
        mProducto = new ArrayList<Producto>();
        mRemesa = new ArrayList<Remesa>();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.647026DE-0EB8-E50D-09D3-2224C3610948]
    // </editor-fold> 
    public ArrayList<Producto> getProducto () {
        return mProducto;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.FFAA13FB-6ADF-1D40-4C07-D65505B675CB]
    // </editor-fold> 
    public void setProducto (ArrayList<Producto> val) {
        this.mProducto = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.01112135-40D4-ADD3-FAAE-2CCAB8646BF7]
    // </editor-fold> 
    public ArrayList<Remesa> getRemesa () {
        return mRemesa;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.1C2292DD-91D3-5C56-8A12-D13F0620AB5B]
    // </editor-fold> 
    public void setRemesa (ArrayList<Remesa> val) {
        this.mRemesa = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.2CC720E9-7E27-DCC2-5776-2D77B432D580]
    // </editor-fold> 
    public String verRemesa (String path) {
        String resumenRemesa = "";
        try
        {
            FileReader fr = null;
            fr = new FileReader(path);
            BufferedReader bf = new BufferedReader(fr);
            String linea;
            while ((linea = bf.readLine()) != null) {
                if (linea.substring(0 ,4).compareTo("5180")==0)
                { //leo presentador
                    resumenRemesa+=linea.substring(28, 68)+"\n";
                }
                else
                {
                   if(linea.substring(0, 4).compareTo("5680")==0)
                      resumenRemesa+=linea.substring(28, 68)+"\t"+linea.substring(88, 98)+"\n";
                }
           }
        }
        catch (IOException ex)
        {
            Logger.getLogger(Sucursal.class.getName()).log(Level.SEVERE, null, ex);
        }
        return resumenRemesa;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.F6137D90-5864-98E0-69F6-C2C70043B992]
    // </editor-fold> 
    public void incorporaRemesa (String path) throws ParseException {
        try
        {
            FileReader fr = null;
            fr = new FileReader(path);
            BufferedReader bf = new BufferedReader(fr);
            String linea;
            String fechaRemesa="";
            while ((linea = bf.readLine()) != null) {
                if (linea.substring(0 ,4).compareTo("5180")==0)
                { //leo presentador
                    int i,encontrado=0;
                    for(i=0;i<mProducto.size();i++) {
                            if(linea.substring(28, 68).trim().compareTo(mProducto.get(i).getTitular().trim())==0) {
                                encontrado=1;
                                break;//obtenemos el índice por el número de cuenta
                            }
                       }
                    Remesa rem = new Remesa();
                    rem.setPresentador(mProducto.get(i));
                    mRemesa.add(rem);
                } else if(linea.substring(0,4).compareTo("5380")==0){
                    fechaRemesa=linea.substring(22, 28);
                }
                else
                {
                   if(linea.substring(0, 4).compareTo("5680")==0) {
                       OperRemesa oper= new OperRemesa();
                       int encontrado=0,i;
                       for(i=0;i<mProducto.size();i++) {
                            if(linea.substring(68, 88).compareTo(mProducto.get(i).getNumeroProducto())==0) {
                                encontrado=1;
                                break;//obtenemos el índice por el número de cuenta
                            }
                       }
                       if(encontrado==1) {
                           DecimalFormat df1 = new DecimalFormat("######,##");
                           Number n=df1.parse(linea.substring(88,98));
                           oper.setCambioSaldo(n.floatValue()*-1);
                           oper.setDescripcion(mRemesa.get(mRemesa.size()-1).getPresentador().getTitular());
                           SimpleDateFormat df2=new SimpleDateFormat("ddMMyy");
                           oper.setFechaOperacion(df2.parse(fechaRemesa));
                           mProducto.get(i).getMovimiento().add(oper);
                           mRemesa.get(mRemesa.size()-1).getOperRemesa().add(oper);
                       }
                   }
                }
           }
        }
        catch (IOException ex)
        {
            Logger.getLogger(Sucursal.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.0AF773C9-5275-2564-9FB0-6B89E1C80748]
    // </editor-fold> 
    public int posCuenta (String nCuenta) {
        for(int i=0;i<mProducto.size();i++)
            if(mProducto.get(i).getNumeroProducto().compareTo(nCuenta)==0)
                return i;
        return -1;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.FFEA940E-EFB5-B736-68C1-38472BB7ADCB]
    // </editor-fold> 
    public boolean anadirMovimiento (String nCuenta, float importe, String descrip) {
        if(mProducto.get(posCuenta(nCuenta)).getSaldo()+importe<0 && importe<0) {
            return false; //da error
        }
        else { //TRATAMIENTO DE ERROR. Sólo entra si control (de error) es "true"
            Movimiento nuevo=new Movimiento();
            nuevo.setCambioSaldo(importe);
            nuevo.setDescripcion(descrip);
            mProducto.get(posCuenta(nCuenta)).getMovimiento().add(nuevo);
            return true;
        }
    }

}

